function [Fu,Fe,Gi,Hi,gradientG,ZN,ZD]=determinationFuFe_armax(theta_init_tot,vector_order,Ts)


na=vector_order(1); nb=vector_order(2); nc=vector_order(3); nk=vector_order(4);

if nc==0, error('When nc=0, you must use ARX as model type'); end;
if na==0, error('When na=0, you must use FIR as model type'); end;

theta_init=theta_init_tot(1:(na+nb));

% Gwd=delay*B/A (sans dela z^-n_k) 
if na>=nb, Gwd=(ss(tf([0, theta_init((na+1):(na+nb))',zeros(1,na-nb)],[1,theta_init(1:na)'],Ts)));
else Gwd=(ss(tf([0,theta_init((na+1):(na+nb))'],[1,theta_init(1:na)',zeros(1,-na+nb)],Ts))); end;


invC=ss(tf([1,zeros(1,nc)],[1,theta_init_tot((na+nb+1):end)'],Ts));


oness=ss(tf(1,1,Ts));








Basis=[-Gwd;oness]*delay(nk,Ts)*invC;


%error('c')


if na>1,
for iii=2:na,
    
    matrix=eye(iii)*oness; 
    matrix=([matrix(1:(iii-1),:);matrix(iii-1,:)*delay(1,Ts);matrix(iii,:)]);
    Basis=(matrix*Basis);
end;
end;

if nb>1,
for iii=2:nb,
    
    matrix=eye(na+iii-1)*oness; 
    matrix=([matrix;matrix(end,:)*delay(1,Ts)]);
    Basis=(matrix*Basis);
end;
end;


Fu=[Basis;zeros(nc,1)*oness];

AFe=blkdiag([-theta_init(1:na)';eye(na-1),zeros(na-1,1)],[-theta_init_tot((na+nb+1):end)';eye(nc-1),zeros(nc-1,1)]);
BFe=[[1;zeros(na-1,1)];[1;zeros(nc-1,1)]];
CFe=[-[eye(na),zeros(na,nc)];zeros(nb,na+nc);[zeros(nc,na),eye(nc)]]; DFe=zeros(na+nc+nb,1);

Fe=ss(AFe,BFe,CFe,DFe,Ts);

% Gi Hi
if na>=(nb+nk-1), Gi=(ss(tf([zeros(1,nk),theta_init((na+1):(na+nb))',zeros(1,na-nb-nk+1)],[1,theta_init(1:na)'],Ts)));
else Gi=(ss(tf([zeros(1,nk),theta_init((na+1):(na+nb))'],[1,theta_init(1:na)',zeros(1,-na+nb+nk-1)],Ts))); end;

if na>=nc, Hi=(ss(tf([1,theta_init_tot((na+nb+1):end)',zeros(1,na-nc)],[1,theta_init(1:na)'],Ts)));
else Hi=(ss(tf([1,theta_init_tot((na+nb+1):end)'],[1,theta_init(1:na)',zeros(1,-na+nc)],Ts))); end;

denG=(ss(tf([1,zeros(1,na)],[1,theta_init(1:na)'],Ts)));


Basis=[-Gwd;oness]*delay(nk,Ts)*denG;


%error('c')


if na>1,
for iii=2:na,
    
    matrix=eye(iii)*oness; 
    matrix=([matrix(1:(iii-1),:);matrix(iii-1,:)*delay(1,Ts);matrix(iii,:)]);
    Basis=(matrix*Basis);
end;
end;

if nb>1,
for iii=2:nb,
    
    matrix=eye(na+iii-1)*oness; 
    matrix=([matrix;matrix(end,:)*delay(1,Ts)]);
    Basis=(matrix*Basis);
end;
end;

gradientG=[Basis;oness*zeros(nc,1)];


Basis=delay(nk,Ts);

if nb>1,
for iii=2:nb,
    
    matrix=eye(iii-1)*oness; 
    matrix=([matrix;matrix(end,:)*delay(1,Ts)]);
    Basis=(matrix*Basis);
end;
end;

ZN=[zeros(1,na)*oness,Basis.',zeros(1,nc)];

Basis=delay(1,Ts);

if na>1,
for iii=2:na,
    
    matrix=eye(iii-1)*oness; 
    matrix=([matrix;matrix(end,:)*delay(1,Ts)]);
    Basis=(matrix*Basis);
end;
end;

ZD=[Basis.',zeros(1,nb+nc)*oness];


