function [Fu,Fe,Gi,Hi,gradientG,ZN,ZD]=determinationFuFe_bj(theta_init_tot,vector_order,Ts)


nb=vector_order(1); nc=vector_order(2); nd=vector_order(3); nf=vector_order(4); nk=vector_order(5);

if nf==0, error('When nf=0, you must use FIR as model type'); end;

if nc+nd==0, error('When nc+nd=0, you must use OE as model type'); end;

thetaG=[theta_init_tot(1:(nb));theta_init_tot((nb+nc+nd+1):end)];
thetaH=[theta_init_tot((nb+1):(nb+nc+nd))];



% Gwd=delay*B/F (sans dlay z^(-n_k)) 
if nf>=nb, Gwd=(ss(tf([0, thetaG(1:(nb))',zeros(1,nf-nb)],[1,thetaG((nb+1):(nb+nf))'],Ts)));
else Gwd=(ss(tf([0,thetaG(1:(nb))'],[1,thetaG((nb+1):(nb+nf))',zeros(1,-nf+nb)],Ts))); end;

if nd>=nc, H=(ss(tf([1, thetaH(1:(nc))',zeros(1,nd-nc)],[1,thetaH((nc+1):(nc+nd))'],Ts)));
else H=(ss(tf([1,thetaH(1:(nc))'],[1,thetaH((nc+1):(nc+nd))',zeros(1,-nd+nc)],Ts))); end;

invH=inv(H);

invF=(ss(tf([1,zeros(1,nf)],[1,thetaG((nb+1):(nb+nf))'],Ts)));
%error('c')

oness=ss(tf(1,1,Ts));



Basis=[oness;-Gwd]*delay(nk,Ts)*invH*invF;



%error('c')

if nb>1,
for iii=2:nb,
    
    matrix=eye(iii)*oness; 
    matrix=([matrix(1:(iii-1),:);matrix(iii-1,:)*delay(1,Ts);matrix(iii,:)]);
    Basis=(matrix*Basis);
    
   
end;
end;



if nf>1,
for iii=2:nf,
    
    matrix=eye(nb+iii-1)*oness; 
    matrix=([matrix;matrix(end,:)*delay(1,Ts)]);
    Basis=(matrix*Basis);
    
end;
end;


Fu=[Basis(1:nb);zeros(nc+nd,1)*oness;Basis((nb+1):end)];


if nc==0,
AFe=[-thetaH((nc+1):end)';eye(nd-1),zeros(nd-1,1)];
BFe=[[1;zeros(nd-1,1)]];
CFe=[zeros(nb,nc+nd);-[eye(nd)];zeros(nf,nc+nd)]; DFe=zeros(nb+nc+nd+nf,1);
elseif nd==0,
AFe=[-thetaH(1:end)';eye(nc-1),zeros(nc-1,1)];
BFe=[[1;zeros(nc-1,1)]];
CFe=[zeros(nb,nc+nd);[eye(nc)];zeros(nf,nc+nd)]; DFe=zeros(nb+nc+nd+nf,1);
else
AFe=blkdiag([-thetaH(1:nc)';eye(nc-1),zeros(nc-1,1)],[-thetaH((nc+1):end)';eye(nd-1),zeros(nd-1,1)]);
BFe=[[1;zeros(nc-1,1)];[1;zeros(nd-1,1)]];
CFe=[zeros(nb,nc+nd);[eye(nc),zeros(nc,nd)];-[zeros(nd,nc),eye(nd)];zeros(nf,nc+nd)]; DFe=zeros(nb+nc+nd+nf,1);
end;
Fe=ss(AFe,BFe,CFe,DFe,Ts);



if nf>=(nb+nk-1), Gi=(ss(tf([zeros(1,nk), thetaG(1:(nb))',zeros(1,nf-nb-nk+1)],[1,thetaG((nb+1):(nb+nf))'],Ts)));
else Gi=(ss(tf([zeros(1,nk), thetaG(1:(nb))'],[1,thetaG((nb+1):(nb+nf))',zeros(1,-nf+nb+nk-1)],Ts))); end;

Hi=H;

Basis=[oness;-Gwd]*delay(nk,Ts)*invF;



%error('c')

if nb>1,
for iii=2:nb,
    
    matrix=eye(iii)*oness; 
    matrix=([matrix(1:(iii-1),:);matrix(iii-1,:)*delay(1,Ts);matrix(iii,:)]);
    Basis=(matrix*Basis);
    
   
end;
end;



if nf>1,
for iii=2:nf,
    
    matrix=eye(nb+iii-1)*oness; 
    matrix=([matrix;matrix(end,:)*delay(1,Ts)]);
    Basis=(matrix*Basis);
    
end;
end;


gradientG=[Basis(1:nb);zeros(nc+nd,1)*oness;Basis((nb+1):end)];



Basis=delay(nk,Ts);

if nb>1,
for iii=2:nb,
    
    matrix=eye(iii-1)*oness; 
    matrix=([matrix;matrix(end,:)*delay(1,Ts)]);
    Basis=(matrix*Basis);
end;
end;

ZN=[Basis.',zeros(1,nc+nd+nf)*oness];

Basis=delay(1,Ts);

if nf>1,
for iii=2:nf,
    
    matrix=eye(iii-1)*oness; 
    matrix=([matrix;matrix(end,:)*delay(1,Ts)]);
    Basis=(matrix*Basis);
end;
end;

ZD=[zeros(1,nb+nc+nd)*oness,Basis.'];

