
function [Pthetath,minimizedtrace,PHI]=optimalexpdesignToptimal_sep(theta_init,vector_order,Ts,var_e_i,maximalcost,ndata,typemodel,typespectrum,controller,parameter_opt)

maximalcost_u=maximalcost(1);
maximalcost_y=maximalcost(2);


if strcmp(typemodel,'arx')
    [Fu,Fe,Gi,Hi]=determinationFuFe_arx(theta_init,vector_order,Ts);
elseif strcmp(typemodel,'armax')
    [Fu,Fe,Gi,Hi]=determinationFuFe_armax(theta_init,vector_order,Ts);
elseif strcmp(typemodel,'oe')
    [Fu,Fe,Gi,Hi]=determinationFuFe_oe(theta_init,vector_order,Ts);
elseif strcmp(typemodel,'bj')
    [Fu,Fe,Gi,Hi]=determinationFuFe_bj(theta_init,vector_order,Ts);
elseif strcmp(typemodel,'fir')
    [Fu,Fe,Gi,Hi]=determinationFuFe_fir(theta_init,vector_order,Ts);
else
    error('Not a valid model structure');
end;






if strcmp(typespectrum,'whitenoise')
    
M=parameter_opt(1);


if isobject(controller),
Cid=ssbal(ss(controller));
Sid=inv(1+Cid*Gi);
Sid=ssbal(Sid);
CSid=Cid*Sid;
CSid=minreal(ssbal(CSid),1e-7);
Tid=Gi*CSid;
Tid=minreal(ssbal(Tid),1e-7);
GSid=Gi*Sid;
GSid=minreal(ssbal(GSid),1e-7);

Fr=Fu*Sid;
Fr=ssbal(Fr);
Febis=ssbal(Fe)-ssbal(CSid*Hi*Fu);
Febis=ssbal(Febis);

Fu=Fr;
Fe=Febis;

%Fu=minreal(Fr);
%Fe=minreal(Febis);

[fso,vecfs]=calculMarkov_tf(Sid,M);
bbbx=[fso,vecfs];
[fsoy,vecfsy]=calculMarkov_tf(GSid,M);
bbbxy=[fsoy,vecfsy];

else 
    
[fso,vecfs]=calculMarkov_tf(Gi,M);
bbbxy=[fso,vecfs];
bbbx=[1;zeros(M,1)]';

end;

[Fo,vecFm,alpha]=calculMarkov(Fu,Fe,M);

Mbar=ndata*alpha;
nbrpara=size(Mbar,1);
Mo=(ndata/var_e_i)*Fo;
vecM=(ndata/var_e_i)*vecFm;


setlmis([]);
[X,nX,sX]=lmivar(1,[nbrpara 1]);
eltrace=diag(sX);



[sigma,nsigma,ssigma]=lmivar(2,[1 1]);
if M>0
[corrvec,ncorrvec,scorrvec]=lmivar(2,[M 1]);  %corresponds to C^T
[QQ,nQQ,sQQ]=lmivar(1,[M 1]);
scoo=[kroprod(scorrvec,eye(nbrpara))];
[coo,ncoo,scoo]=lmivar(3,scoo);

Bpos=[1;zeros(M-1,1)];
Apos=[zeros(1,M-1),0;eye(M-1),zeros(M-1,1)];
end;


lmiterm([-1,1,1,sigma],1,1);
if M>0
lmiterm([-2,1,1,QQ],1,1);
lmiterm([-2,1,1,QQ],-Apos',Apos);
lmiterm([-2,1,2,QQ],-Apos',Bpos);
lmiterm([-2,1,2,corrvec],1,1);
lmiterm([-2,2,2,sigma],1,0.5,'s');
lmiterm([-2,2,2,QQ],-Bpos',Bpos);
counter=2;
else counter=1;
end;


%counter=counter+1;
%lmiterm([-counter,1,1,X],1,1);

counter=counter+1;
lmiterm([-counter,1,1,X],eye(nbrpara),eye(nbrpara));
lmiterm([-counter,1,2,0],eye(nbrpara));
lmiterm([-counter,2,2,0],Mbar);
lmiterm([-counter,2,2,sigma],Mo,1);
if M>0, lmiterm([-counter,2,2,coo],vecM,0.5,'s'); end;

counter=counter+1;
lmiterm([counter,1,1,0],-maximalcost_u);
lmiterm([counter,1,1,sigma],bbbx(1),1);
if M>0, lmiterm([counter,1,1,corrvec],bbbx(2:end),0.5,'s'); end;


counter=counter+1;
lmiterm([counter,1,1,0],-maximalcost_y);
lmiterm([counter,1,1,sigma],bbbxy(1),1);
if M>0, lmiterm([counter,1,1,corrvec],bbbxy(2:end),0.5,'s'); end;



kappaopt=getlmis;


basis_c=zeros(nX,1);
for jjjj=1:length(eltrace);
    element=eltrace(jjjj);
    basis_c(element)=1;
end;


%c = [basis_c;zeros(nQQ-nX,1)];

if M>0,
    c = [basis_c;zeros(nQQ-nX,1)];
else
    c = [basis_c;zeros(nsigma-nX,1)];
end;


flag=1;
options=[1e-12,1000,1e12,10,flag];
[coutopt,xopt]=mincx(kappaopt,c,options);
sigmaopt=dec2mat(kappaopt,xopt,sigma);
if M>0 corrvecopt=dec2mat(kappaopt,xopt,corrvec); 
corrphiu=[sigmaopt;corrvecopt]; 
else corrphiu=sigmaopt; end;

PHI=corrphiu;

iPthetath=(Mbar+corrphiu(1)*Mo);
if M>0
iPthetath=iPthetath+vecM*kroprod(corrphiu(2:end),eye(nbrpara));
end;
Pthetath=inv(iPthetath);



minimizedtrace=coutopt;
    
elseif strcmp(typespectrum,'multisinus')
    
vec_w_sinus=parameter_opt(:,1)';
Nsinus=length(vec_w_sinus);

if isobject(controller),
Cid=ssbal(ss(controller));
Sid=inv(1+Cid*Gi);
Sid=ssbal(Sid);
CSid=Cid*Sid;
CSid=minreal(ssbal(CSid),1e-7);
Tid=Gi*CSid;
Tid=minreal(ssbal(Tid),1e-7);
GSid=Gi*Sid;
GSid=minreal(ssbal(GSid),1e-7);

Fr=Sid*Fu;
Fr=ssbal(Fr);
Febis=ssbal(Fe)-ssbal(CSid*Hi*Fu);
Febis=ssbal(Febis);

Fu=Fr;
Fe=(Febis);

vecfs=frxav(Sid,vec_w_sinus);
vecfsy=frxav(GSid,vec_w_sinus);
bbbx=0.5*(abs(vecfs).^2);
bbbxy=0.5*(abs(vecfsy).^2);


else 
    
vecfsy=frxav(Gi,vec_w_sinus);
bbbxy=0.5*(abs(vecfsy).^2);
bbbx=(0.5*ones(1,Nsinus));

end;

Mbar=ndata*H2power(Fe);
nbrpara=size(Mbar,1);

vecM=[];


for lll=1:Nsinus,
puls=vec_w_sinus(lll);
Frw=frxav(Fu,puls);
Mw=(ndata/(2*var_e_i))*real(Frw*Frw');
vecM=[vecM,Mw];
end; 


setlmis([]);
[X,nX,sX]=lmivar(1,[nbrpara 1]);
eltrace=diag(sX);
[corrvec,ncorrvec,scorrvec]=lmivar(2,[Nsinus 1]);  %corresponds to C^T
sdiagA=diag(scorrvec);
diagA=lmivar(3,sdiagA);
scoo=[kroprod(scorrvec,eye(nbrpara))];
[coo,ncoo,scoo]=lmivar(3,scoo);

lmiterm([-1,1,1,diagA],1,1);
counter=1;


counter=counter+1;
lmiterm([-counter,1,1,X],eye(nbrpara),eye(nbrpara));
lmiterm([-counter,1,2,0],eye(nbrpara));
lmiterm([-counter,2,2,0],Mbar);
lmiterm([-counter,2,2,coo],vecM,0.5,'s'); 

counter=counter+1;
lmiterm([counter,1,1,0],-maximalcost_u);
lmiterm([counter,1,1,corrvec],bbbx,0.5,'s'); 

counter=counter+1;
lmiterm([counter,1,1,0],-maximalcost_y);
lmiterm([counter,1,1,corrvec],bbbxy,0.5,'s'); 


kappaopt=getlmis;
%c = [-1;zeros(ncoo-1,1)];

basis_c=zeros(nX,1);
for jjjj=1:length(eltrace);
    element=eltrace(jjjj);
    basis_c(element)=1;
end;


c = [basis_c;zeros(ncoo-nX,1)];



flag=1;
options=[1e-12,1000,1e12,10,flag];
[coutopt,xopt]=mincx(kappaopt,c,options);
Asqopt=dec2mat(kappaopt,xopt,corrvec); 








iPthetath=Mbar+vecM*kroprod(Asqopt,eye(nbrpara));

Pthetath=inv(iPthetath);




    

PHI=sqrt(Asqopt);



minimizedtrace=coutopt;

else
    error('Not a valid spectrum type');
end;    





